#! /usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright (C) 2012 ~ 2013 Deepin, Inc.
#               2012 ~ 2013 Long Wei
#
# Author:     Long Wei <yilang2007lw@gmail.com>
# Maintainer: Long Wei <yilang2007lw@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free oftware Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

class NMDeviceType:

    NM_DEVICE_TYPE_UNKNOWN    = 0
    NM_DEVICE_TYPE_ETHERNET   = 1
    NM_DEVICE_TYPE_WIFI       = 2
    NM_DEVICE_TYPE_UNUSED1    = 3
    NM_DEVICE_TYPE_UNUSED2    = 4
    NM_DEVICE_TYPE_BT         = 5 
    NM_DEVICE_TYPE_OLPC_MESH  = 6
    NM_DEVICE_TYPE_WIMAX      = 7
    NM_DEVICE_TYPE_MODEM      = 8
    NM_DEVICE_TYPE_INFINIBAND = 9
    NM_DEVICE_TYPE_BOND       = 10
    NM_DEVICE_TYPE_VLAN       = 11

class NMDeviceState():

    NM_DEVICE_STATE_UNKNOWN      = 0
    NM_DEVICE_STATE_UNMANAGED    = 10
    NM_DEVICE_STATE_UNAVAILABLE  = 20
    NM_DEVICE_STATE_DISCONNECTED = 30
    NM_DEVICE_STATE_PREPARE      = 40
    NM_DEVICE_STATE_CONFIG       = 50
    NM_DEVICE_STATE_NEED_AUTH    = 60
    NM_DEVICE_STATE_IP_CONFIG    = 70
    NM_DEVICE_STATE_IP_CHECK     = 80
    NM_DEVICE_STATE_SECONDARIES  = 90
    NM_DEVICE_STATE_ACTIVATED    = 100
    NM_DEVICE_STATE_DEACTIVATING = 110
    NM_DEVICE_STATE_FAILED       = 120

class  NMClientPermission():
        
    NM_CLIENT_PERMISSION_NONE = 0
    NM_CLIENT_PERMISSION_ENABLE_DISABLE_NETWORK = 1
    NM_CLIENT_PERMISSION_ENABLE_DISABLE_WIFI = 2
    NM_CLIENT_PERMISSION_ENABLE_DISABLE_WWAN = 3
    NM_CLIENT_PERMISSION_ENABLE_DISABLE_WIMAX = 4
    NM_CLIENT_PERMISSION_SLEEP_WAKE = 5
    NM_CLIENT_PERMISSION_NETWORK_CONTROL = 6
    NM_CLIENT_PERMISSION_WIFI_SHARE_PROTECTED = 7
    NM_CLIENT_PERMISSION_WIFI_SHARE_OPEN = 8
    NM_CLIENT_PERMISSION_SETTINGS_MODIFY_SYSTEM = 9
    NM_CLIENT_PERMISSION_SETTINGS_MODIFY_OWN = 10
    NM_CLIENT_PERMISSION_SETTINGS_MODIFY_HOSTNAME = 11
    NM_CLIENT_PERMISSION_LAST = NM_CLIENT_PERMISSION_SETTINGS_MODIFY_HOSTNAME

class NMClientPermissionResult():

    NM_CLIENT_PERMISSION_RESULT_UNKNOWN = 0
    NM_CLIENT_PERMISSION_RESULT_YES = 1
    NM_CLIENT_PERMISSION_RESULT_AUTH = 2
    NM_CLIENT_PERMISSION_RESULT_NO = 3

class NMWimaxNspNetworkType():

    NM_WIMAX_NSP_NETWORK_TYPE_UNKNOWN         = 0
    NM_WIMAX_NSP_NETWORK_TYPE_HOME            = 1
    NM_WIMAX_NSP_NETWORK_TYPE_PARTNER         = 2
    NM_WIMAX_NSP_NETWORK_TYPE_ROAMING_PARTNER = 3

class NMRemoteSettingsError():

    NM_REMOTE_SETTINGS_ERROR_UNKNOWN = 0
    NM_REMOTE_SETTINGS_ERROR_CONNECTION_REMOVED = 1
    NM_REMOTE_SETTINGS_ERROR_CONNECTION_UNAVAILABLE = 2

class NMSecretAgentError():
    
    NM_SECRET_AGENT_ERROR_NOT_AUTHORIZED = 0
    NM_SECRET_AGENT_ERROR_INVALID_CONNECTION = 1
    NM_SECRET_AGENT_ERROR_USER_CANCELED = 2
    NM_SECRET_AGENT_ERROR_AGENT_CANCELED = 3
    NM_SECRET_AGENT_ERROR_INTERNAL_ERROR = 4
    NM_SECRET_AGENT_ERROR_NO_SECRETS = 5

class NMSecretAgentGetSecretsFlags():

    NM_SECRET_AGENT_GET_SECRETS_FLAG_NONE = 0x0
    NM_SECRET_AGENT_GET_SECRETS_FLAG_ALLOW_INTERACTION = 0x1
    NM_SECRET_AGENT_GET_SECRETS_FLAG_REQUEST_NEW = 0x2

class NMConnectionError():
    
    NM_CONNECTION_ERROR_UNKNOWN = 0
    NM_CONNECTION_ERROR_CONNECTION_SETTING_NOT_FOUND = 1
    NM_CONNECTION_ERROR_CONNECTION_TYPE_INVALID = 2 
    NM_CONNECTION_ERROR_SETTING_NOT_FOUND = 3

class NMSettingError():
    
    NM_SETTING_ERROR_UNKNOWN = 0
    NM_SETTING_ERROR_PROPERTY_NOT_FOUND = 1
    NM_SETTING_ERROR_PROPERTY_NOT_SECRET = 2
    NM_SETTING_ERROR_PROPERTY_TYPE_MISMATCH = 3

class  NMSettingSecretFlags():

    NM_SETTING_SECRET_FLAG_NONE         = 0x00000000
    NM_SETTING_SECRET_FLAG_AGENT_OWNED  = 0x00000001
    NM_SETTING_SECRET_FLAG_NOT_SAVED    = 0x00000002
    NM_SETTING_SECRET_FLAG_NOT_REQUIRED = 0x00000004

class NMSettingCompareFlags():

    NM_SETTING_COMPARE_FLAG_EXACT = 0x00000000
    NM_SETTING_COMPARE_FLAG_FUZZY = 0x00000001
    NM_SETTING_COMPARE_FLAG_IGNORE_ID = 0x00000002
    NM_SETTING_COMPARE_FLAG_IGNORE_SECRETS = 0x00000004
    NM_SETTING_COMPARE_FLAG_IGNORE_AGENT_OWNED_SECRETS = 0x00000008
    NM_SETTING_COMPARE_FLAG_IGNORE_NOT_SAVED_SECRETS = 0x00000010

class NMSettingParamFlags():

    NM_SETTING_PARAM_SERIALIZE = 0x00000001
    NM_SETTING_PARAM_REQUIRED  = 0x00000002
    NM_SETTING_PARAM_SECRET    = 0x00000004
    NM_SETTING_PARAM_FUZZY_IGNORE = 0x00000008
    
class  NMSettingHashFlags():

    NM_SETTING_HASH_FLAG_ALL = 0x00000000
    NM_SETTING_HASH_FLAG_NO_SECRETS = 0x00000001
    NM_SETTING_HASH_FLAG_ONLY_SECRETS = 0x00000002

class NMSettingDiffResult():

    NM_SETTING_DIFF_RESULT_UNKNOWN = 0x00000000
    NM_SETTING_DIFF_RESULT_IN_A =    0x00000001
    NM_SETTING_DIFF_RESULT_IN_B =    0x00000002

class NMSettingConnectionError():

    NM_SETTING_CONNECTION_ERROR_UNKNOWN = 0
    NM_SETTING_CONNECTION_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_CONNECTION_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_CONNECTION_ERROR_TYPE_SETTING_NOT_FOUND = 3
    NM_SETTING_CONNECTION_ERROR_IP_CONFIG_NOT_ALLOWED = 4

class NMSettingWiredError():

    NM_SETTING_WIRED_ERROR_UNKNOWN = 0
    NM_SETTING_WIRED_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_WIRED_ERROR_MISSING_PROPERTY = 2

class NMSettingWirelessError():

    NM_SETTING_WIRELESS_ERROR_UNKNOWN = 0
    NM_SETTING_WIRELESS_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_WIRELESS_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_WIRELESS_ERROR_MISSING_SECURITY_SETTING = 3
    NM_SETTING_WIRELESS_ERROR_CHANNEL_REQUIRES_BAND = 4

class NMSettingWirelessSecurityError():

    NM_SETTING_WIRELESS_SECURITY_ERROR_UNKNOWN = 0
    NM_SETTING_WIRELESS_SECURITY_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_WIRELESS_SECURITY_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_WIRELESS_SECURITY_ERROR_MISSING_802_1X_SETTING = 3
    NM_SETTING_WIRELESS_SECURITY_ERROR_LEAP_REQUIRES_802_1X = 4
    NM_SETTING_WIRELESS_SECURITY_ERROR_LEAP_REQUIRES_USERNAME = 5
    NM_SETTING_WIRELESS_SECURITY_ERROR_SHARED_KEY_REQUIRES_WEP = 6

class NMWepKeyType():

    NM_WEP_KEY_TYPE_UNKNOWN = 0
    NM_WEP_KEY_TYPE_KEY = 1
    NM_WEP_KEY_TYPE_PASSPHRASE = 2
    NM_WEP_KEY_TYPE_LAST = NM_WEP_KEY_TYPE_PASSPHRASE

class NMSettingBluetoothError():

    NM_SETTING_BLUETOOTH_ERROR_UNKNOWN = 0
    NM_SETTING_BLUETOOTH_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_BLUETOOTH_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_BLUETOOTH_ERROR_TYPE_SETTING_NOT_FOUND = 3

class NMSettingSerialError():

    NM_SETTING_SERIAL_ERROR_UNKNOWN = 0
    NM_SETTING_SERIAL_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_SERIAL_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_SERIAL_ERROR_MISSING_PPP_SETTING = 3

class NMSettingCdmaError():

    NM_SETTING_CDMA_ERROR_UNKNOWN = 0
    NM_SETTING_CDMA_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_CDMA_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_CDMA_ERROR_MISSING_SERIAL_SETTING = 3

class NMSettingGsmError():

    NM_SETTING_GSM_ERROR_UNKNOWN = 0
    NM_SETTING_GSM_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_GSM_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_GSM_ERROR_MISSING_SERIAL_SETTING = 3

class NMSettingWimaxError():

    NM_SETTING_WIMAX_ERROR_UNKNOWN = 0
    NM_SETTING_WIMAX_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_WIMAX_ERROR_MISSING_PROPERTY = 2

class NMSettingBondError():

    NM_SETTING_BOND_ERROR_UNKNOWN = 0
    NM_SETTING_BOND_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_BOND_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_BOND_ERROR_INVALID_OPTION  = 3
    NM_SETTING_BOND_ERROR_MISSING_OPTION = 4

class NMSettingInfinibandError():

    NM_SETTING_INFINIBAND_ERROR_UNKNOWN = 0
    NM_SETTING_INFINIBAND_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_INFINIBAND_ERROR_MISSING_PROPERTY = 2

class NMSettingVlanError():

    NM_SETTING_VLAN_ERROR_UNKNOWN = 0
    NM_SETTING_VLAN_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_VLAN_ERROR_MISSING_PROPERTY = 2

class NMVlanPriorityMap():
    NM_VLAN_INGRESS_MAP = 0
    NM_VLAN_EGRESS_MAP = 1

class NMVlanFlags():
    NM_VLAN_FLAG_REORDER_HEADERS = 0x1
    NM_VLAN_FLAG_GVRP            = 0x2
    NM_VLAN_FLAG_LOOSE_BINDING   = 0x4

class NMSettingOlpcMeshError():

    NM_SETTING_OLPC_MESH_ERROR_UNKNOWN = 0
    NM_SETTING_OLPC_MESH_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_OLPC_MESH_ERROR_MISSING_PROPERTY = 2

class NMSetting8021xCKFormat():

    NM_SETTING_802_1X_CK_FORMAT_UNKNOWN = 0
    NM_SETTING_802_1X_CK_FORMAT_X509 = 1
    NM_SETTING_802_1X_CK_FORMAT_RAW_KEY = 2
    NM_SETTING_802_1X_CK_FORMAT_PKCS12 = 3

class NMSetting8021xCKScheme():

    NM_SETTING_802_1X_CK_SCHEME_UNKNOWN = 0
    NM_SETTING_802_1X_CK_SCHEME_BLOB = 1
    NM_SETTING_802_1X_CK_SCHEME_PATH = 2

class NMSetting8021xError():

    NM_SETTING_802_1X_ERROR_UNKNOWN = 0
    NM_SETTING_802_1X_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_802_1X_ERROR_MISSING_PROPERTY = 2

class NMSettingIP4ConfigError():

    NM_SETTING_IP4_CONFIG_ERROR_UNKNOWN = 0
    NM_SETTING_IP4_CONFIG_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_IP4_CONFIG_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_IP4_CONFIG_ERROR_NOT_ALLOWED_FOR_METHOD = 3

class NMSettingIP6ConfigError():

    NM_SETTING_IP6_CONFIG_ERROR_UNKNOWN = 0
    NM_SETTING_IP6_CONFIG_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_IP6_CONFIG_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_IP6_CONFIG_ERROR_NOT_ALLOWED_FOR_METHOD = 3

class NMSettingIP6ConfigPrivacy():

    NM_SETTING_IP6_CONFIG_PRIVACY_UNKNOWN = -1
    NM_SETTING_IP6_CONFIG_PRIVACY_DISABLED = 0
    NM_SETTING_IP6_CONFIG_PRIVACY_PREFER_PUBLIC_ADDR = 1
    NM_SETTING_IP6_CONFIG_PRIVACY_PREFER_TEMP_ADDR = 2

class NMSettingPPPError():

    NM_SETTING_PPP_ERROR_UNKNOWN = 0
    NM_SETTING_PPP_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_PPP_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_PPP_ERROR_REQUIRE_MPPE_NOT_ALLOWED = 3

class NMSettingPPPOEError():

    NM_SETTING_PPPOE_ERROR_UNKNOWN = 0
    NM_SETTING_PPPOE_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_PPPOE_ERROR_MISSING_PROPERTY = 2
    NM_SETTING_PPPOE_ERROR_MISSING_PPP_SETTING = 3

class NMSettingVpnError():

    NM_SETTING_VPN_ERROR_UNKNOWN = 0
    NM_SETTING_VPN_ERROR_INVALID_PROPERTY = 1
    NM_SETTING_VPN_ERROR_MISSING_PROPERTY = 2

class NMUtilsSecurityType():

    NMU_SEC_INVALID = 0
    NMU_SEC_NONE = 1
    NMU_SEC_STATIC_WEP = 2
    NMU_SEC_LEAP = 3
    NMU_SEC_DYNAMIC_WEP = 4
    NMU_SEC_WPA_PSK = 5
    NMU_SEC_WPA_ENTERPRISE = 6
    NMU_SEC_WPA2_PSK = 7
    NMU_SEC_WPA2_ENTERPRISE = 8
